
function filterBy(arr, dataType) {
    // Створюємо новий масив, до якого будемо додавати елементи, що підходять за вказаним типом даних
    const filteredArr = [];

    // Ітеруємося по кожному елементу масиву
    for (let i = 0; i < arr.length; i++) {
        // Перевіряємо тип поточного елемента за допомогою оператора typeof
        if (typeof arr[i] !== dataType) {
            //Якщо тип поточного елемента не співпадає з вказаним типом dataType, то він додається до масиву filteredArr за допомогою методу push().
            filteredArr.push(arr[i]);
        }
    }

    // Повертаємо новий масив, що містить елементи, які не співпадають за вказаним типом даних
    return filteredArr;
}

// Приклад використання
const arr = ['hello', 'world', 23, '23', null];
const filteredArr = filterBy(arr, 'string');
console.log(filteredArr); // [23, null]


/*
Теоретичні питання

1.Опишіть своїми словами як працює метод forEach.
2.Як очистити масив?
3.Як можна перевірити, що та чи інша змінна є масивом?

1.Метод forEach() - це метод масиву, який дозволяє виконувати певну функцію для кожного елемента масиву.
 При виклику методу forEach() передається функція-колбек, яка буде виконуватися для кожного елемента масиву.
 Функція-колбек приймає три аргументи: значення поточного елемента, індекс поточного елемента та сам масив, якому належить елемент.
 Використовуючи метод forEach(), ми можемо виконати певну операцію для кожного елемента масиву без необхідності використання циклу for.

 2.Існує кілька способів очистки масиву в JavaScript.
 Один з них - це просто присвоїти порожній масив змінній, яка посилається на масив, який потрібно очистити.
 myArray = []; // очистити масив

Ще один спосіб - це використовувати метод splice(), щоб видалити всі елементи масиву. Наприклад:
myArray.splice(0, myArray.length); // очистити масив

3.Є кілька способів перевірки, чи є змінна масивом в JavaScript.
Один з них - це використання оператора Array.isArray(), який перевіряє, чи є переданий об'єкт масивом. Наприклад:
const myArray = [1, 2, 3];
console.log(Array.isArray(myArray)); // true

Інший спосіб - це перевірити наявність властивості length, оскільки тільки масиви мають таку властивість. Наприклад:
const myArray = [1, 2, 3];
console.log(myArray.length !== undefined); // true
Однак, цей спосіб може бути неточним, оскільки інші об'єкти також можуть мати властивість length. Тому рекомендовано використовувати оператор Array.isArray()


 */